BSDK.NET - BlomURBEX 3D Data Provider Software Development Kit

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Members

Public Member Functions
BSDKW::BShape Class Reference

Abstract class that is capable to receive a shape from SDK. More...

List of all members.

## Public Types
Shapes attributes constants
enum | BLshapeattr { BL_SHAPE_ATTR_BUILDING_BLOCK_ID_INDEX = NatBShape.BLshapeattr.BL_SHAPE_ATTR_BUILDING_BLOCK_ID_INDEX, BL_SHAPE_ATTR_BUILDING_PART_TYPE = NatBShape.BLshapeattr.BL_SHAPE_ATTR_BUILDING_PART_TYPE, BL_SHAPE_ATTR_BUILDING_PART_ID = NatBShape.BLshapeattr.BL_SHAPE_ATTR_BUILDING_PART_ID }
| Shapes attributes identifiers. More...
enum | BLbuildingpart { BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_FACADE = NatBShape.BLbuildingpart.BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_FACADE, BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_ROOF = NatBShape.BLbuildingpart.BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_ROOF, BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_SOCKET = NatBShape.BLbuildingpart.BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_SOCKET, BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_PEDIMENT = NatBShape.BLbuildingpart.BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_PEDIMENT }
| Building part identifiers in BSDK::BShape::BL_SHAPE_ATTR_BUILDING_PART_TYPE attribute. More...
enum | BLshapetype { BL_TRIANGLES_ARRAY = NatBShape.BLshapetype.BL_TRIANGLES_ARRAY }
| Identifies shape types. More...
## Public Member Functions
abstract void | Initialize (NatBShape.BLshapetype shapeType, int vertexCount, byte[] colorComponents)
| Configures current shape.
abstract void | SetAttribute (NatBShape.BLshapeattr attributeName, bool[] value)
| Sets shape attribute.
abstract void | SetAttribute (NatBShape.BLshapeattr attributeName, byte[] value)
abstract void | SetAttribute (NatBShape.BLshapeattr attributeName, int[] value)
abstract void | SetAttribute (NatBShape.BLshapeattr attributeName, double[] value)
abstract void | SetAttribute (NatBShape.BLshapeattr attributeName, string[] value)
abstract int[] | GetWritableVertexesIndexes ()
| Requests user to allocate enough memory to save vertexes indexes.

## Detailed Description

Abstract class that is capable to receive a shape from SDK.

See also:
  BMesh, BModel

## Member Enumeration Documentation

enum BSDKW::BShape::BLbuildingpart

Building part identifiers in BSDK::BShape::BL_SHAPE_ATTR_BUILDING_PART_TYPE attribute.

See also:
  BSDK::BShape::SetAttribute

Enumerator:

  BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_FACADE |
  BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_ROOF |
  BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_SOCKET |
  BL_SHAPE_ATTR_BUILDING_PART_TYPE_VALUE_PEDIMENT |

enum BSDKW::BShape::BLshapeattr

Shapes attributes identifiers.

See also:
  BSDK::BShape::SetAttribute

Enumerator:

  BL_SHAPE_ATTR_BUILDING_BLOCK_ID_INDEX |
  BL_SHAPE_ATTR_BUILDING_PART_TYPE |
  BL_SHAPE_ATTR_BUILDING_PART_ID |

enum BSDKW::BShape::BLshapetype

Identifies shape types.

Currently, only one type is used.

See also:
  BSDK::BShape::Initialize

Enumerator:

  BL_TRIANGLES_ARRAY |

## Member Function Documentation

abstract int [] BSDKW::BShape::GetWritableVertexesIndexes | ( |  | ) | `[pure virtual]`

Requests user to allocate enough memory to save vertexes indexes.

Returned memory should not be overriden or deleted until loading task was finalized.

Returns:
  An integer array containing at least vertexCount integers.

abstract void BSDKW::BShape::Initialize | ( | NatBShape.BLshapetype | shapeType,
|  | int | vertexCount,
|  | byte[] | colorComponents
| ) |  | `[pure virtual]`

Configures current shape.

Parameters:

  shapeType | Shape type: CURRENTLY supported only BSDK::BL_TRIANGLES_ARRAY
  vertexCount | Indicates how many vertex does this shape contain
  colorComponents | Array containing 4 bytes, defines a default color for this shape as RGBA.

abstract void BSDKW::BShape::SetAttribute | ( | NatBShape.BLshapeattr | attributeName,
|  | string[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BShape::SetAttribute | ( | NatBShape.BLshapeattr | attributeName,
|  | double[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BShape::SetAttribute | ( | NatBShape.BLshapeattr | attributeName,
|  | int[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BShape::SetAttribute | ( | NatBShape.BLshapeattr | attributeName,
|  | byte[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BShape::SetAttribute | ( | NatBShape.BLshapeattr | attributeName,
|  | bool[] | value
| ) |  | `[pure virtual]`

Sets shape attribute.

Client application implementation should be ready to receive unknown attribute names.

Parameters:

  attributeName | Attribute name
  value | Attribute values

See also:
  BShape::SetAttribute

The documentation for this class was generated from the following file:

- BSDK.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events